﻿<#
.Synopsis
    Creates new IO.Swagger.Model.Pet object.

.Description
    Creates new IO.Swagger.Model.Pet object.

.Parameter Id
    ID of pet.

.Parameter Category
    Category of pet.

.Parameter Name
    Name of pet.

.Parameter PhotoUrls
    PhotoUrls.

.Parameter Tags
    Tags

.Parameter Status
    Status.

.Example
    New-Pet -Id 1 -Name 'foo' -Category (
        New-Category -Id 2 -Name 'bar'
    ) -PhotoUrls @(
        'http://example.com/foo',
        'http://example.com/bar'
    ) -Tags (
        New-Tag -Id 3 -Name 'baz'
    ) -Status 'Available'

.Inputs
    System.Nullable[long]

    IO.Swagger.Model.Category

    System.String

    System.Collections.Generic.List[string]

    System.Collections.Generic.List[IO.Swagger.Model.Tag]

    System.Nullable[IO.Swagger.Model.Pet+StatusEnum]

.Outputs

.Notes
    This function is automatically generated by the Swagger Codegen.

.Link
    https://github.com/swagger-api/swagger-codegen
#>
function New-Pet {
    [CmdletBinding()]
    Param (
        [Parameter(Position = 0, ValueFromPipelineByPropertyName = $true)]
        [System.Nullable[long]]
        ${Id},

        [Parameter(Position = 1, ValueFromPipelineByPropertyName = $true)]
        [IO.Swagger.Model.Category]
        ${Category},

        [Parameter(Position = 2, ValueFromPipelineByPropertyName = $true, Mandatory = $true)]
        [string]
        ${Name},

        [Parameter(Position = 3, ValueFromPipelineByPropertyName = $true, Mandatory = $true)]
        [System.Collections.Generic.List[string]]
        ${PhotoUrls},

        [Parameter(Position = 4, ValueFromPipelineByPropertyName = $true)]
        [System.Collections.Generic.List[IO.Swagger.Model.Tag]]
        ${Tags},

        [Parameter(Position = 5, ValueFromPipelineByPropertyName = $true)]
        [System.Nullable[IO.Swagger.Model.Pet+StatusEnum]]
        ${Status}
    )

    Process {
        'Creating object: IO.Swagger.Model.Pet' | Write-Verbose
        $PSBoundParameters | Out-DebugParameter | Write-Debug

        New-Object -TypeName IO.Swagger.Model.Pet -ArgumentList @(
            ${Id},
            ${Category},
            ${Name},
            ${PhotoUrls},
            ${Tags},
            ${Status}
        )
    }
}