﻿<#
.Synopsis
    Updates a pet in the store.

.Description
    Updates a pet in the store.

.Parameter Id
    ID of pet to return.

.Example
    Update-PetUsingParameterSet -Id 1 -Name 'foo' -Status 'Available'

.Example
    Update-PetUsingParameterSet -Id 1 -Name 'foo' -Status 'Available'

.Example
    Update-PetUsingParameterSet -Pet $Pet

.Example
    $Pet | Update-PetUsingParameterSet

.Inputs
    System.Nullable[long]

    System.String

    System.String

    IO.Swagger.Model.Pet

.Outputs

.Notes
    This function is automatically generated by the Swagger Codegen.

.Link
    https://github.com/swagger-api/swagger-codegen
#>

function Update-PetUsingParameterSet {
    [CmdletBinding(DefaultParameterSetName = 'UpdatePetWithForm')]
    Param (
        [Parameter(Position = 0, ValueFromPipelineByPropertyName = $true, Mandatory = $true, ParameterSetName = 'UpdatePetWithForm')]
        [System.Nullable[long]]
        ${Id},

        [Parameter(Position = 1, ValueFromPipelineByPropertyName = $true, ParameterSetName = 'UpdatePetWithForm')]
        [string]
        ${Name},

        [Parameter(Position = 2, ValueFromPipelineByPropertyName = $true, ParameterSetName = 'UpdatePetWithForm')]
        [string]
        ${Status},

        [Parameter(Position = 0, ValueFromPipeline = $true, Mandatory = $true, ParameterSetName = 'UpdatePet')]
        [IO.Swagger.Model.Pet]
        ${Pet}
    )

    Process {
        switch ($PSCmdlet.ParameterSetName) {
            'UpdatePetWithForm' {
                'Calling method: UpdatePetWithForm' | Write-Verbose
                $PSBoundParameters | Out-DebugParameter | Write-Debug

                $Script:PetApi.UpdatePetWithForm(
                    ${Id},
                    ${Name},
                    ${Status}
                )
                break
            }

            'UpdatePet' {
                'Calling method: UpdatePet' | Write-Verbose
                $PSBoundParameters | Out-DebugParameter | Write-Debug

                $Script:PetApi.UpdatePet(
                    ${Pet}
                )
                break
            }

            default {
                throw 'Invalid ParameterSet!'
            }
        }
    }
}